Subject: Re: Do not lock temp relations

From: Daniil Davydov <[email-masked]>
Date: Tue, 22 Oct 2024 18:25:01 +0700

> Yes. Our implementation restrictions preclude access to the contents
> of another session's temp tables, but it is not forbidden to do DDL
> on them so long as no content access is required. (Without this,
> it'd be problematic for example to clean out a crashed session's temp
> tables. See the "orphan temporary tables" logic in autovacuum.c.)

Indeed, a potentially dangerous situation may arise when both the
autovacuum and client process attempt to delete the contents of a temporary
namespace. But there is a patch (6faca9ae2878c8f642a2e5748d2dbb2b91341bec)
that protects us from race condition in this case. -- Best regards,
Daniil Davydov.